Index: trunk/SophyaLib/TArray/Makefile
===================================================================
--- trunk/SophyaLib/TArray/Makefile	(revision 2957)
+++ trunk/SophyaLib/TArray/Makefile	(revision 3007)
@@ -13,15 +13,19 @@
 $(SOPHYAOBJP)basarr.o: basarr.cc $(SOPHYAINCP)sopnamsp.h \
   $(SOPHYAINCP)machdefs.h \
-  $(SOPHYAINCP)pexceptions.h basarr.h \
-  $(SOPHYAINCP)anydataobj.h \
-  $(SOPHYAINCP)mutyv.h \
-  $(SOPHYAINCP)timestamp.h \
-  $(SOPHYAINCP)objfio.h \
-  $(SOPHYAINCP)ppersist.h \
-  $(SOPHYAINCP)gnumd5.h \
-  $(SOPHYAINCP)ppfbinstream.h \
-  $(SOPHYAINCP)rawstream.h \
-  $(SOPHYAINCP)ppfnametag.h \
-  $(SOPHYAINCP)dvlist.h
+  $(SOPHYAINCP)pexceptions.h \
+  $(SOPHYAINCP)machdefs.h basarr.h \
+  $(SOPHYAINCP)anydataobj.h \
+  $(SOPHYAINCP)mutyv.h \
+  $(SOPHYAINCP)timestamp.h \
+  $(SOPHYAINCP)objfio.h \
+  $(SOPHYAINCP)anydataobj.h \
+  $(SOPHYAINCP)ppersist.h \
+  $(SOPHYAINCP)pexceptions.h \
+  $(SOPHYAINCP)gnumd5.h \
+  $(SOPHYAINCP)ppfbinstream.h \
+  $(SOPHYAINCP)rawstream.h \
+  $(SOPHYAINCP)ppfnametag.h \
+  $(SOPHYAINCP)dvlist.h \
+  $(SOPHYAINCP)mutyv.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  basarr.cc
  
@@ -31,4 +35,5 @@
   $(SOPHYAINCP)fiondblock.h \
   $(SOPHYAINCP)ppersist.h \
+  $(SOPHYAINCP)pexceptions.h \
   $(SOPHYAINCP)gnumd5.h \
   $(SOPHYAINCP)ppfbinstream.h \
@@ -36,42 +41,56 @@
   $(SOPHYAINCP)ppfnametag.h \
   $(SOPHYAINCP)ndatablock.h \
-  $(SOPHYAINCP)anydataobj.h fioarr.h tarray.h \
-  basarr.h $(SOPHYAINCP)mutyv.h \
-  $(SOPHYAINCP)timestamp.h \
-  $(SOPHYAINCP)objfio.h \
-  $(SOPHYAINCP)dvlist.h utilarr.h tmatrix.h \
-  tmatrix_tsnl.h tvector.h tvector_tsnl.h \
+  $(SOPHYAINCP)anydataobj.h fioarr.h \
+  $(SOPHYAINCP)machdefs.h tarray.h basarr.h \
+  $(SOPHYAINCP)anydataobj.h \
+  $(SOPHYAINCP)mutyv.h \
+  $(SOPHYAINCP)timestamp.h \
+  $(SOPHYAINCP)objfio.h \
+  $(SOPHYAINCP)dvlist.h \
+  $(SOPHYAINCP)mutyv.h \
+  $(SOPHYAINCP)ndatablock.h utilarr.h \
+  tmatrix.h tmatrix_tsnl.h tvector.h tvector_tsnl.h \
+  $(SOPHYAINCP)ppersist.h \
   $(SOPHYAINCP)datatype.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  fioarr.cc
  
-$(SOPHYAOBJP)matharr.o: matharr.cc $(SOPHYAINCP)sopnamsp.h \
+$(SOPHYAOBJP)matharr.o: matharr.cc \
+  $(SOPHYAINCP)sopnamsp.h \
   $(SOPHYAINCP)machdefs.h matharr.h tarray.h \
   basarr.h $(SOPHYAINCP)anydataobj.h \
-  $(SOPHYAINCP)mutyv.h \
-  $(SOPHYAINCP)timestamp.h \
-  $(SOPHYAINCP)objfio.h \
-  $(SOPHYAINCP)ppersist.h \
-  $(SOPHYAINCP)pexceptions.h \
-  $(SOPHYAINCP)gnumd5.h \
-  $(SOPHYAINCP)ppfbinstream.h \
-  $(SOPHYAINCP)rawstream.h \
-  $(SOPHYAINCP)ppfnametag.h \
-  $(SOPHYAINCP)dvlist.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)mutyv.h \
+  $(SOPHYAINCP)timestamp.h \
+  $(SOPHYAINCP)objfio.h \
+  $(SOPHYAINCP)anydataobj.h \
+  $(SOPHYAINCP)ppersist.h \
+  $(SOPHYAINCP)pexceptions.h \
+  $(SOPHYAINCP)gnumd5.h \
+  $(SOPHYAINCP)ppfbinstream.h \
+  $(SOPHYAINCP)rawstream.h \
+  $(SOPHYAINCP)ppfnametag.h \
+  $(SOPHYAINCP)dvlist.h \
+  $(SOPHYAINCP)mutyv.h \
   $(SOPHYAINCP)ndatablock.h utilarr.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  matharr.cc
  
-$(SOPHYAOBJP)sopemtx.o: sopemtx.cc $(SOPHYAINCP)sopnamsp.h \
-  $(SOPHYAINCP)machdefs.h sopemtx.h tmatrix.h \
-  tarray.h basarr.h $(SOPHYAINCP)anydataobj.h \
-  $(SOPHYAINCP)mutyv.h \
-  $(SOPHYAINCP)timestamp.h \
-  $(SOPHYAINCP)objfio.h \
-  $(SOPHYAINCP)ppersist.h \
-  $(SOPHYAINCP)pexceptions.h \
-  $(SOPHYAINCP)gnumd5.h \
-  $(SOPHYAINCP)ppfbinstream.h \
-  $(SOPHYAINCP)rawstream.h \
-  $(SOPHYAINCP)ppfnametag.h \
-  $(SOPHYAINCP)dvlist.h \
+$(SOPHYAOBJP)sopemtx.o: sopemtx.cc \
+  $(SOPHYAINCP)sopnamsp.h \
+  $(SOPHYAINCP)machdefs.h sopemtx.h \
+  tmatrix.h tarray.h basarr.h \
+  $(SOPHYAINCP)anydataobj.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)mutyv.h \
+  $(SOPHYAINCP)timestamp.h \
+  $(SOPHYAINCP)objfio.h \
+  $(SOPHYAINCP)anydataobj.h \
+  $(SOPHYAINCP)ppersist.h \
+  $(SOPHYAINCP)pexceptions.h \
+  $(SOPHYAINCP)gnumd5.h \
+  $(SOPHYAINCP)ppfbinstream.h \
+  $(SOPHYAINCP)rawstream.h \
+  $(SOPHYAINCP)ppfnametag.h \
+  $(SOPHYAINCP)dvlist.h \
+  $(SOPHYAINCP)mutyv.h \
   $(SOPHYAINCP)ndatablock.h utilarr.h \
   tmatrix_tsnl.h tvector.h tvector_tsnl.h \
@@ -81,15 +100,19 @@
 $(SOPHYAOBJP)tarray.o: tarray.cc $(SOPHYAINCP)sopnamsp.h \
   $(SOPHYAINCP)machdefs.h \
-  $(SOPHYAINCP)pexceptions.h tarray.h \
-  basarr.h $(SOPHYAINCP)anydataobj.h \
-  $(SOPHYAINCP)mutyv.h \
-  $(SOPHYAINCP)timestamp.h \
-  $(SOPHYAINCP)objfio.h \
-  $(SOPHYAINCP)ppersist.h \
-  $(SOPHYAINCP)gnumd5.h \
-  $(SOPHYAINCP)ppfbinstream.h \
-  $(SOPHYAINCP)rawstream.h \
-  $(SOPHYAINCP)ppfnametag.h \
-  $(SOPHYAINCP)dvlist.h \
+  $(SOPHYAINCP)pexceptions.h \
+  $(SOPHYAINCP)machdefs.h tarray.h basarr.h \
+  $(SOPHYAINCP)anydataobj.h \
+  $(SOPHYAINCP)mutyv.h \
+  $(SOPHYAINCP)timestamp.h \
+  $(SOPHYAINCP)objfio.h \
+  $(SOPHYAINCP)anydataobj.h \
+  $(SOPHYAINCP)ppersist.h \
+  $(SOPHYAINCP)pexceptions.h \
+  $(SOPHYAINCP)gnumd5.h \
+  $(SOPHYAINCP)ppfbinstream.h \
+  $(SOPHYAINCP)rawstream.h \
+  $(SOPHYAINCP)ppfnametag.h \
+  $(SOPHYAINCP)dvlist.h \
+  $(SOPHYAINCP)mutyv.h \
   $(SOPHYAINCP)ndatablock.h utilarr.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  tarray.cc
@@ -98,40 +121,51 @@
   $(SOPHYAINCP)sopnamsp.h \
   $(SOPHYAINCP)machdefs.h tarrinit.h \
-  $(SOPHYAINCP)sophyainit.h fioarr.h tarray.h \
+  $(SOPHYAINCP)sophyainit.h \
+  $(SOPHYAINCP)machdefs.h fioarr.h tarray.h \
   basarr.h $(SOPHYAINCP)anydataobj.h \
   $(SOPHYAINCP)mutyv.h \
   $(SOPHYAINCP)timestamp.h \
   $(SOPHYAINCP)objfio.h \
-  $(SOPHYAINCP)ppersist.h \
-  $(SOPHYAINCP)pexceptions.h \
-  $(SOPHYAINCP)gnumd5.h \
-  $(SOPHYAINCP)ppfbinstream.h \
-  $(SOPHYAINCP)rawstream.h \
-  $(SOPHYAINCP)ppfnametag.h \
-  $(SOPHYAINCP)dvlist.h \
-  $(SOPHYAINCP)ndatablock.h utilarr.h \
-  tmatrix.h tmatrix_tsnl.h tvector.h tvector_tsnl.h
+  $(SOPHYAINCP)anydataobj.h \
+  $(SOPHYAINCP)ppersist.h \
+  $(SOPHYAINCP)pexceptions.h \
+  $(SOPHYAINCP)gnumd5.h \
+  $(SOPHYAINCP)ppfbinstream.h \
+  $(SOPHYAINCP)rawstream.h \
+  $(SOPHYAINCP)ppfnametag.h \
+  $(SOPHYAINCP)dvlist.h \
+  $(SOPHYAINCP)mutyv.h \
+  $(SOPHYAINCP)ndatablock.h utilarr.h \
+  tmatrix.h tmatrix_tsnl.h tvector.h tvector_tsnl.h \
+  $(SOPHYAINCP)ppersist.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  tarrinit.cc
  
-$(SOPHYAOBJP)tmatrix.o: tmatrix.cc $(SOPHYAINCP)sopnamsp.h \
-  $(SOPHYAINCP)machdefs.h \
-  $(SOPHYAINCP)pexceptions.h tmatrix.h \
-  tarray.h basarr.h $(SOPHYAINCP)anydataobj.h \
-  $(SOPHYAINCP)mutyv.h \
-  $(SOPHYAINCP)timestamp.h \
-  $(SOPHYAINCP)objfio.h \
-  $(SOPHYAINCP)ppersist.h \
-  $(SOPHYAINCP)gnumd5.h \
-  $(SOPHYAINCP)ppfbinstream.h \
-  $(SOPHYAINCP)rawstream.h \
-  $(SOPHYAINCP)ppfnametag.h \
-  $(SOPHYAINCP)dvlist.h \
+$(SOPHYAOBJP)tmatrix.o: tmatrix.cc \
+  $(SOPHYAINCP)sopnamsp.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)pexceptions.h \
+  $(SOPHYAINCP)machdefs.h tmatrix.h tarray.h \
+  basarr.h $(SOPHYAINCP)anydataobj.h \
+  $(SOPHYAINCP)mutyv.h \
+  $(SOPHYAINCP)timestamp.h \
+  $(SOPHYAINCP)objfio.h \
+  $(SOPHYAINCP)anydataobj.h \
+  $(SOPHYAINCP)ppersist.h \
+  $(SOPHYAINCP)pexceptions.h \
+  $(SOPHYAINCP)gnumd5.h \
+  $(SOPHYAINCP)ppfbinstream.h \
+  $(SOPHYAINCP)rawstream.h \
+  $(SOPHYAINCP)ppfnametag.h \
+  $(SOPHYAINCP)dvlist.h \
+  $(SOPHYAINCP)mutyv.h \
   $(SOPHYAINCP)ndatablock.h utilarr.h \
   tmatrix_tsnl.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  tmatrix.cc
  
-$(SOPHYAOBJP)tvector.o: tvector.cc $(SOPHYAINCP)sopnamsp.h \
-  $(SOPHYAINCP)machdefs.h \
-  $(SOPHYAINCP)pexceptions.h tvector.h \
+$(SOPHYAOBJP)tvector.o: tvector.cc \
+  $(SOPHYAINCP)sopnamsp.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)pexceptions.h \
+  $(SOPHYAINCP)machdefs.h tvector.h \
   tmatrix.h tarray.h basarr.h \
   $(SOPHYAINCP)anydataobj.h \
@@ -139,17 +173,22 @@
   $(SOPHYAINCP)timestamp.h \
   $(SOPHYAINCP)objfio.h \
-  $(SOPHYAINCP)ppersist.h \
-  $(SOPHYAINCP)gnumd5.h \
-  $(SOPHYAINCP)ppfbinstream.h \
-  $(SOPHYAINCP)rawstream.h \
-  $(SOPHYAINCP)ppfnametag.h \
-  $(SOPHYAINCP)dvlist.h \
+  $(SOPHYAINCP)anydataobj.h \
+  $(SOPHYAINCP)ppersist.h \
+  $(SOPHYAINCP)pexceptions.h \
+  $(SOPHYAINCP)gnumd5.h \
+  $(SOPHYAINCP)ppfbinstream.h \
+  $(SOPHYAINCP)rawstream.h \
+  $(SOPHYAINCP)ppfnametag.h \
+  $(SOPHYAINCP)dvlist.h \
+  $(SOPHYAINCP)mutyv.h \
   $(SOPHYAINCP)ndatablock.h utilarr.h \
   tmatrix_tsnl.h tvector_tsnl.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  tvector.cc
  
-$(SOPHYAOBJP)utilarr.o: utilarr.cc $(SOPHYAINCP)sopnamsp.h \
+$(SOPHYAOBJP)utilarr.o: utilarr.cc \
+  $(SOPHYAINCP)sopnamsp.h \
   $(SOPHYAINCP)machdefs.h utilarr.h \
   $(SOPHYAINCP)mutyv.h \
+  $(SOPHYAINCP)machdefs.h \
   $(SOPHYAINCP)timestamp.h \
   $(SOPHYAINCP)objfio.h \
Index: trunk/SophyaLib/TArray/smakefile
===================================================================
--- trunk/SophyaLib/TArray/smakefile	(revision 2957)
+++ trunk/SophyaLib/TArray/smakefile	(revision 3007)
@@ -13,15 +13,19 @@
 $(SOPHYAOBJP)basarr.o: basarr.cc $(SOPHYAINCP)sopnamsp.h \
   $(SOPHYAINCP)machdefs.h \
-  $(SOPHYAINCP)pexceptions.h basarr.h \
-  $(SOPHYAINCP)anydataobj.h \
-  $(SOPHYAINCP)mutyv.h \
-  $(SOPHYAINCP)timestamp.h \
-  $(SOPHYAINCP)objfio.h \
-  $(SOPHYAINCP)ppersist.h \
-  $(SOPHYAINCP)gnumd5.h \
-  $(SOPHYAINCP)ppfbinstream.h \
-  $(SOPHYAINCP)rawstream.h \
-  $(SOPHYAINCP)ppfnametag.h \
-  $(SOPHYAINCP)dvlist.h
+  $(SOPHYAINCP)pexceptions.h \
+  $(SOPHYAINCP)machdefs.h basarr.h \
+  $(SOPHYAINCP)anydataobj.h \
+  $(SOPHYAINCP)mutyv.h \
+  $(SOPHYAINCP)timestamp.h \
+  $(SOPHYAINCP)objfio.h \
+  $(SOPHYAINCP)anydataobj.h \
+  $(SOPHYAINCP)ppersist.h \
+  $(SOPHYAINCP)pexceptions.h \
+  $(SOPHYAINCP)gnumd5.h \
+  $(SOPHYAINCP)ppfbinstream.h \
+  $(SOPHYAINCP)rawstream.h \
+  $(SOPHYAINCP)ppfnametag.h \
+  $(SOPHYAINCP)dvlist.h \
+  $(SOPHYAINCP)mutyv.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  basarr.cc
  
@@ -31,4 +35,5 @@
   $(SOPHYAINCP)fiondblock.h \
   $(SOPHYAINCP)ppersist.h \
+  $(SOPHYAINCP)pexceptions.h \
   $(SOPHYAINCP)gnumd5.h \
   $(SOPHYAINCP)ppfbinstream.h \
@@ -36,42 +41,56 @@
   $(SOPHYAINCP)ppfnametag.h \
   $(SOPHYAINCP)ndatablock.h \
-  $(SOPHYAINCP)anydataobj.h fioarr.h tarray.h \
-  basarr.h $(SOPHYAINCP)mutyv.h \
-  $(SOPHYAINCP)timestamp.h \
-  $(SOPHYAINCP)objfio.h \
-  $(SOPHYAINCP)dvlist.h utilarr.h tmatrix.h \
-  tmatrix_tsnl.h tvector.h tvector_tsnl.h \
+  $(SOPHYAINCP)anydataobj.h fioarr.h \
+  $(SOPHYAINCP)machdefs.h tarray.h basarr.h \
+  $(SOPHYAINCP)anydataobj.h \
+  $(SOPHYAINCP)mutyv.h \
+  $(SOPHYAINCP)timestamp.h \
+  $(SOPHYAINCP)objfio.h \
+  $(SOPHYAINCP)dvlist.h \
+  $(SOPHYAINCP)mutyv.h \
+  $(SOPHYAINCP)ndatablock.h utilarr.h \
+  tmatrix.h tmatrix_tsnl.h tvector.h tvector_tsnl.h \
+  $(SOPHYAINCP)ppersist.h \
   $(SOPHYAINCP)datatype.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  fioarr.cc
  
-$(SOPHYAOBJP)matharr.o: matharr.cc $(SOPHYAINCP)sopnamsp.h \
+$(SOPHYAOBJP)matharr.o: matharr.cc \
+  $(SOPHYAINCP)sopnamsp.h \
   $(SOPHYAINCP)machdefs.h matharr.h tarray.h \
   basarr.h $(SOPHYAINCP)anydataobj.h \
-  $(SOPHYAINCP)mutyv.h \
-  $(SOPHYAINCP)timestamp.h \
-  $(SOPHYAINCP)objfio.h \
-  $(SOPHYAINCP)ppersist.h \
-  $(SOPHYAINCP)pexceptions.h \
-  $(SOPHYAINCP)gnumd5.h \
-  $(SOPHYAINCP)ppfbinstream.h \
-  $(SOPHYAINCP)rawstream.h \
-  $(SOPHYAINCP)ppfnametag.h \
-  $(SOPHYAINCP)dvlist.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)mutyv.h \
+  $(SOPHYAINCP)timestamp.h \
+  $(SOPHYAINCP)objfio.h \
+  $(SOPHYAINCP)anydataobj.h \
+  $(SOPHYAINCP)ppersist.h \
+  $(SOPHYAINCP)pexceptions.h \
+  $(SOPHYAINCP)gnumd5.h \
+  $(SOPHYAINCP)ppfbinstream.h \
+  $(SOPHYAINCP)rawstream.h \
+  $(SOPHYAINCP)ppfnametag.h \
+  $(SOPHYAINCP)dvlist.h \
+  $(SOPHYAINCP)mutyv.h \
   $(SOPHYAINCP)ndatablock.h utilarr.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  matharr.cc
  
-$(SOPHYAOBJP)sopemtx.o: sopemtx.cc $(SOPHYAINCP)sopnamsp.h \
-  $(SOPHYAINCP)machdefs.h sopemtx.h tmatrix.h \
-  tarray.h basarr.h $(SOPHYAINCP)anydataobj.h \
-  $(SOPHYAINCP)mutyv.h \
-  $(SOPHYAINCP)timestamp.h \
-  $(SOPHYAINCP)objfio.h \
-  $(SOPHYAINCP)ppersist.h \
-  $(SOPHYAINCP)pexceptions.h \
-  $(SOPHYAINCP)gnumd5.h \
-  $(SOPHYAINCP)ppfbinstream.h \
-  $(SOPHYAINCP)rawstream.h \
-  $(SOPHYAINCP)ppfnametag.h \
-  $(SOPHYAINCP)dvlist.h \
+$(SOPHYAOBJP)sopemtx.o: sopemtx.cc \
+  $(SOPHYAINCP)sopnamsp.h \
+  $(SOPHYAINCP)machdefs.h sopemtx.h \
+  tmatrix.h tarray.h basarr.h \
+  $(SOPHYAINCP)anydataobj.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)mutyv.h \
+  $(SOPHYAINCP)timestamp.h \
+  $(SOPHYAINCP)objfio.h \
+  $(SOPHYAINCP)anydataobj.h \
+  $(SOPHYAINCP)ppersist.h \
+  $(SOPHYAINCP)pexceptions.h \
+  $(SOPHYAINCP)gnumd5.h \
+  $(SOPHYAINCP)ppfbinstream.h \
+  $(SOPHYAINCP)rawstream.h \
+  $(SOPHYAINCP)ppfnametag.h \
+  $(SOPHYAINCP)dvlist.h \
+  $(SOPHYAINCP)mutyv.h \
   $(SOPHYAINCP)ndatablock.h utilarr.h \
   tmatrix_tsnl.h tvector.h tvector_tsnl.h \
@@ -81,15 +100,19 @@
 $(SOPHYAOBJP)tarray.o: tarray.cc $(SOPHYAINCP)sopnamsp.h \
   $(SOPHYAINCP)machdefs.h \
-  $(SOPHYAINCP)pexceptions.h tarray.h \
-  basarr.h $(SOPHYAINCP)anydataobj.h \
-  $(SOPHYAINCP)mutyv.h \
-  $(SOPHYAINCP)timestamp.h \
-  $(SOPHYAINCP)objfio.h \
-  $(SOPHYAINCP)ppersist.h \
-  $(SOPHYAINCP)gnumd5.h \
-  $(SOPHYAINCP)ppfbinstream.h \
-  $(SOPHYAINCP)rawstream.h \
-  $(SOPHYAINCP)ppfnametag.h \
-  $(SOPHYAINCP)dvlist.h \
+  $(SOPHYAINCP)pexceptions.h \
+  $(SOPHYAINCP)machdefs.h tarray.h basarr.h \
+  $(SOPHYAINCP)anydataobj.h \
+  $(SOPHYAINCP)mutyv.h \
+  $(SOPHYAINCP)timestamp.h \
+  $(SOPHYAINCP)objfio.h \
+  $(SOPHYAINCP)anydataobj.h \
+  $(SOPHYAINCP)ppersist.h \
+  $(SOPHYAINCP)pexceptions.h \
+  $(SOPHYAINCP)gnumd5.h \
+  $(SOPHYAINCP)ppfbinstream.h \
+  $(SOPHYAINCP)rawstream.h \
+  $(SOPHYAINCP)ppfnametag.h \
+  $(SOPHYAINCP)dvlist.h \
+  $(SOPHYAINCP)mutyv.h \
   $(SOPHYAINCP)ndatablock.h utilarr.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  tarray.cc
@@ -98,40 +121,51 @@
   $(SOPHYAINCP)sopnamsp.h \
   $(SOPHYAINCP)machdefs.h tarrinit.h \
-  $(SOPHYAINCP)sophyainit.h fioarr.h tarray.h \
+  $(SOPHYAINCP)sophyainit.h \
+  $(SOPHYAINCP)machdefs.h fioarr.h tarray.h \
   basarr.h $(SOPHYAINCP)anydataobj.h \
   $(SOPHYAINCP)mutyv.h \
   $(SOPHYAINCP)timestamp.h \
   $(SOPHYAINCP)objfio.h \
-  $(SOPHYAINCP)ppersist.h \
-  $(SOPHYAINCP)pexceptions.h \
-  $(SOPHYAINCP)gnumd5.h \
-  $(SOPHYAINCP)ppfbinstream.h \
-  $(SOPHYAINCP)rawstream.h \
-  $(SOPHYAINCP)ppfnametag.h \
-  $(SOPHYAINCP)dvlist.h \
-  $(SOPHYAINCP)ndatablock.h utilarr.h \
-  tmatrix.h tmatrix_tsnl.h tvector.h tvector_tsnl.h
+  $(SOPHYAINCP)anydataobj.h \
+  $(SOPHYAINCP)ppersist.h \
+  $(SOPHYAINCP)pexceptions.h \
+  $(SOPHYAINCP)gnumd5.h \
+  $(SOPHYAINCP)ppfbinstream.h \
+  $(SOPHYAINCP)rawstream.h \
+  $(SOPHYAINCP)ppfnametag.h \
+  $(SOPHYAINCP)dvlist.h \
+  $(SOPHYAINCP)mutyv.h \
+  $(SOPHYAINCP)ndatablock.h utilarr.h \
+  tmatrix.h tmatrix_tsnl.h tvector.h tvector_tsnl.h \
+  $(SOPHYAINCP)ppersist.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  tarrinit.cc
  
-$(SOPHYAOBJP)tmatrix.o: tmatrix.cc $(SOPHYAINCP)sopnamsp.h \
-  $(SOPHYAINCP)machdefs.h \
-  $(SOPHYAINCP)pexceptions.h tmatrix.h \
-  tarray.h basarr.h $(SOPHYAINCP)anydataobj.h \
-  $(SOPHYAINCP)mutyv.h \
-  $(SOPHYAINCP)timestamp.h \
-  $(SOPHYAINCP)objfio.h \
-  $(SOPHYAINCP)ppersist.h \
-  $(SOPHYAINCP)gnumd5.h \
-  $(SOPHYAINCP)ppfbinstream.h \
-  $(SOPHYAINCP)rawstream.h \
-  $(SOPHYAINCP)ppfnametag.h \
-  $(SOPHYAINCP)dvlist.h \
+$(SOPHYAOBJP)tmatrix.o: tmatrix.cc \
+  $(SOPHYAINCP)sopnamsp.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)pexceptions.h \
+  $(SOPHYAINCP)machdefs.h tmatrix.h tarray.h \
+  basarr.h $(SOPHYAINCP)anydataobj.h \
+  $(SOPHYAINCP)mutyv.h \
+  $(SOPHYAINCP)timestamp.h \
+  $(SOPHYAINCP)objfio.h \
+  $(SOPHYAINCP)anydataobj.h \
+  $(SOPHYAINCP)ppersist.h \
+  $(SOPHYAINCP)pexceptions.h \
+  $(SOPHYAINCP)gnumd5.h \
+  $(SOPHYAINCP)ppfbinstream.h \
+  $(SOPHYAINCP)rawstream.h \
+  $(SOPHYAINCP)ppfnametag.h \
+  $(SOPHYAINCP)dvlist.h \
+  $(SOPHYAINCP)mutyv.h \
   $(SOPHYAINCP)ndatablock.h utilarr.h \
   tmatrix_tsnl.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  tmatrix.cc
  
-$(SOPHYAOBJP)tvector.o: tvector.cc $(SOPHYAINCP)sopnamsp.h \
-  $(SOPHYAINCP)machdefs.h \
-  $(SOPHYAINCP)pexceptions.h tvector.h \
+$(SOPHYAOBJP)tvector.o: tvector.cc \
+  $(SOPHYAINCP)sopnamsp.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)pexceptions.h \
+  $(SOPHYAINCP)machdefs.h tvector.h \
   tmatrix.h tarray.h basarr.h \
   $(SOPHYAINCP)anydataobj.h \
@@ -139,17 +173,22 @@
   $(SOPHYAINCP)timestamp.h \
   $(SOPHYAINCP)objfio.h \
-  $(SOPHYAINCP)ppersist.h \
-  $(SOPHYAINCP)gnumd5.h \
-  $(SOPHYAINCP)ppfbinstream.h \
-  $(SOPHYAINCP)rawstream.h \
-  $(SOPHYAINCP)ppfnametag.h \
-  $(SOPHYAINCP)dvlist.h \
+  $(SOPHYAINCP)anydataobj.h \
+  $(SOPHYAINCP)ppersist.h \
+  $(SOPHYAINCP)pexceptions.h \
+  $(SOPHYAINCP)gnumd5.h \
+  $(SOPHYAINCP)ppfbinstream.h \
+  $(SOPHYAINCP)rawstream.h \
+  $(SOPHYAINCP)ppfnametag.h \
+  $(SOPHYAINCP)dvlist.h \
+  $(SOPHYAINCP)mutyv.h \
   $(SOPHYAINCP)ndatablock.h utilarr.h \
   tmatrix_tsnl.h tvector_tsnl.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  tvector.cc
  
-$(SOPHYAOBJP)utilarr.o: utilarr.cc $(SOPHYAINCP)sopnamsp.h \
+$(SOPHYAOBJP)utilarr.o: utilarr.cc \
+  $(SOPHYAINCP)sopnamsp.h \
   $(SOPHYAINCP)machdefs.h utilarr.h \
   $(SOPHYAINCP)mutyv.h \
+  $(SOPHYAINCP)machdefs.h \
   $(SOPHYAINCP)timestamp.h \
   $(SOPHYAINCP)objfio.h \