Index: trunk/SophyaLib/Manual/sophya.tex
===================================================================
--- trunk/SophyaLib/Manual/sophya.tex	(revision 3040)
+++ trunk/SophyaLib/Manual/sophya.tex	(revision 3045)
@@ -50,5 +50,4 @@
 \begin{center}
 {\bf \Large Sophya Version: 2.0 (V\_Jul2006) }
-% Document revision 1.0 }
 \end{center}
 \titrebp{1}
@@ -66,5 +65,5 @@
 easy to use, yet powerful classes which can be used by scientists.
 Although some of the SOPHYA modules (SkyMap, Samba, SkyT) 
-have been designed with the specific goal CMB data analysis, most
+have been designed with the specific goal of CMB data analysis, most
 modules presented here have a much broader scope and can be
 used in scientific data analysis and modeling/simulation. 
@@ -104,4 +103,5 @@
 %%%
 \subsection{SOPHYA modules}
+\label{sopmodules}
 The source directory tree 
 \footnote{ CVS: cvsserver.lal.in2p3.fr:/exp/eros/CVSSophya} 
@@ -211,5 +211,5 @@
 The organisation of SOPHYA directories and some of the associated 
 utility programs are described in this section.
-Basic usage of Sophya classes are described in in the following sections.
+Basic usage of Sophya classes is described in the following sections.
 Complete Sophya documentation can be found at our web site
 {\bf http://www.sophya.org}. 
@@ -1989,5 +1989,5 @@
 \newpage
 \section{Building and installing Sophya}
-\subsection{supported platforms}
+\subsection{Supported platforms}
 Presently, the Sophya library has been tested with the following
 compiler/platform pairs:
@@ -1998,8 +1998,8 @@
 OS & compiler \\
 \hline
-Linux (RH)          &     g++  (3.2)  \\
-Linux  (SCL)          &     icc  (8.1)   (Intel compiler) \\
-MacOSX/Darwin 10.3  &         g++ 3.3  \\
-HP/Compaq/DEC Tru64 ( OSF1)  &     cxx  (6.1 , 6.3)  \\
+Linux           &     g++  (3.x 4.0)  \\
+Linux  (SCL)          &     icc - Intel compiler (9.0)   \\
+MacOSX/Darwin 10.3 \, 10.4  &         g++ (3.3  4.0)\\
+HP/Compaq/DEC Tru64 ( OSF1)  &     cxx  (6.1  6.3)  \\
 SGI IRIX64       &     CC   (7.3)   \\
 IBM AIX       &     xlC   (7.x)   \\
@@ -2008,8 +2008,6 @@
 \end{center}
 
-Some of the modules in the Sophya package uses external libraries. The 
-{\bf FitsIOServer} is the example of such a module, where the {\tt libcfitsio.a}
-is used.
-\par
+\subsection{Library and makefile structure}
+% 
 The object files from a given Sophya module are grouped in an archive library 
 with the module's name ({\tt libmodulename.a}). All Sophya modules 
@@ -2023,5 +2021,6 @@
 Each library module has a {\tt Makefile} which compiles the source files
 and build the correspond static (archive) library using the compilation
-rules and flags defined in {\tt \$SOPHYABASE/include/sophyamake.inc}.
+rules and flags defined in \\ 
+\hspace*{5mm} {\tt \$SOPHYABASE/include/sophyamake.inc}. \\
 Each program module has a {\tt Makefile} which compiles and link the 
 corresponding programs using the compilation rules and libraries
@@ -2029,4 +2028,11 @@
 The top level Makefile in BuildMgr/ compiles each library modules
 and builds shared libraries. 
+\par
+Some of the modules in the Sophya package uses external libraries. The 
+{\bf FitsIOServer} is an example of such a module, where the {\tt libcfitsio.a}
+is used. The list of all Sophya modules using external libraries is
+presented in section \ref{sopmodules}.
+The external libraries should be installed before the configure step
+(see below) and the compilation of the corresponding Sophya modules. 
 \par 
 The series of Makefiles use the link to {\tt sophyamake.inc} in BuildMgr.
@@ -2034,5 +2040,5 @@
 {\tt \$SOPHYABASE} environment variable.
 
-\subsection{Installation} 
+\subsection{Build instructions} 
 \label{build}
 The build procedure has two main steps: 
@@ -2185,14 +2191,13 @@
 the smakefiles in each module.
 \item[] {\bf mkmflib:}  c-shell script for creation of library module 
-Makefile / smakefile.
-{\tt  ./mkmflib -sbase /tmp/sbase SUtils } 
+Makefile / smakefile. \\
+\hspace*{5mm} {\tt  ./mkmflib -sbase /tmp/sbase SUtils } 
 \item[] {\b mkmfprog:} 
-{\tt c-shell script for creation of programs module 
-Makefile / smakefile \\
-{\tt ./mkmfprog -sbase /tmp/sbase ProgPI }
+c-shell script for creation of programs module Makefile / smakefile \\
+\hspace*{5mm}  {\tt ./mkmfprog -sbase /tmp/sbase ProgPI }
 \item[] {\bf domkmf:} c-shell script - calls mkmflib for all modules \\
-{\tt ./domkmf -sbase /tmp/sbase}
-\item[] Configuration files for different compilers and OS
-(\tt  Linux\_g++\_make.inc , OSF1\_cxx\_make.inc \ldots }. 
+\hspace*{5mm} {\tt ./domkmf -sbase /tmp/sbase}
+\item[] {\bf xxx\_make.inc:} Configuration files for different compilers and OS
+{\tt ( Linux\_g++\_make.inc , OSF1\_cxx\_make.inc \ldots )}. 
 These files are used to generate {\tt sophyamake.inc} 
 \end{itemize}