Index: trunk/SophyaLib/HiStats/hisprof.h
===================================================================
--- trunk/SophyaLib/HiStats/hisprof.h	(revision 3048)
+++ trunk/SophyaLib/HiStats/hisprof.h	(revision 3049)
@@ -10,7 +10,10 @@
 namespace SOPHYA {
 
+template <class T>  class FitsHandler;
+
 //! 1 dimension profile histograms
 class HProf : public Histo {
   friend class ObjFileIO<HProf>;
+  friend class FitsHandler<Histo>;
 public:
 
Index: trunk/SophyaLib/HiStats/histerr.cc
===================================================================
--- trunk/SophyaLib/HiStats/histerr.cc	(revision 3048)
+++ trunk/SophyaLib/HiStats/histerr.cc	(revision 3049)
@@ -17,5 +17,5 @@
 /*! Constructeur par defaut */
 HistoErr::HistoErr(void)
-: Histo(), mNData(NULL)
+  : Histo(), mNData(NULL), mCorrel(0)
 {
 }
@@ -24,5 +24,5 @@
 /*! Constructeur d'un histo de nBin bins allant de xMin a xMax */
 HistoErr::HistoErr(r_8 xMin, r_8 xMax, int_4 nBin)
-: Histo(xMin,xMax,nBin), mNData(NULL)
+: Histo(xMin,xMax,nBin), mNData(NULL), mCorrel(0)
 {
  this->Errors();
@@ -34,5 +34,5 @@
 /*! Constructeur par copie */
 HistoErr::HistoErr(const HistoErr& H)
-: Histo(H), mNData(NULL)
+: Histo(H), mNData(NULL), mCorrel(H.mCorrel)
 {
  allocate_mNData(H.mBins);
@@ -72,4 +72,5 @@
  Histo::Zero();
  if(mNData) memset(mNData,0,mBins*sizeof(r_8));
+ mCorrel = 0;
 }
 
@@ -128,4 +129,5 @@
 {
  if(mBins<1) return;
+ mCorrel++;
  for(int_4 i=0;i<mBins;i++) {
    if(mNData[i]<1.) continue;
@@ -143,4 +145,5 @@
 {
  if(mBins<1) return;
+ mCorrel--;
  for(int_4 i=0;i<mBins;i++) {
    if(mNData[i]<1.) continue;
@@ -174,4 +177,5 @@
    }
  }
+ mCorrel = hfrom.mCorrel;
 
 }
@@ -192,4 +196,5 @@
   allocate_mNData(h.mBins);
   memcpy(mNData,h.mNData,mBins*sizeof(r_8));
+  mCorrel = h.mCorrel;
 
   return *this;
@@ -213,4 +218,7 @@
 is.GetStr(strg);
 
+// Nombre d'appels a ToCorrel/FromCorrel
+is.Get(dobj->mCorrel);
+
 // Lecture des donnees HistoErr
 is.Get(dobj->mBins);
@@ -230,6 +238,10 @@
 string strg;
 
+// Ecriture entete
 strg = "HistErr";
 os.PutStr(strg);
+
+// Nombre d'appels a ToCorrel/FromCorrel
+os.Put(dobj->mCorrel);
 
 // Ecriture des valeurs
Index: trunk/SophyaLib/HiStats/histerr.h
===================================================================
--- trunk/SophyaLib/HiStats/histerr.h	(revision 3048)
+++ trunk/SophyaLib/HiStats/histerr.h	(revision 3049)
@@ -9,7 +9,11 @@
 namespace SOPHYA {
 
+//  Forward class declaration for Fits handler
+template <class T>  class FitsHandler;
+
 //! 1 dimension histograms with errors given by user
 class HistoErr : public Histo {
   friend class ObjFileIO<HistoErr>;
+  friend class FitsHandler<Histo>;
 public:
 
@@ -66,4 +70,5 @@
   void ToCorrel(void);
   void FromCorrel(void);
+  int_4 NCorrel(void) {return mCorrel;}
 
   //! Fill an histogram with an histogram
@@ -78,4 +83,5 @@
 
   r_8* mNData;    //!< nombre d'entrees dans chaque bin
+  int_4 mCorrel;  //!< Nombre d'appels a ToCorrel(+1) ou FromCorrel(-1)
 };
 
Index: trunk/SophyaLib/HiStats/histos.h
===================================================================
--- trunk/SophyaLib/HiStats/histos.h	(revision 3048)
+++ trunk/SophyaLib/HiStats/histos.h	(revision 3049)
@@ -1,5 +1,5 @@
 // This may look like C code, but it is really -*- C++ -*-
 //
-// $Id: histos.h,v 1.21 2006-08-07 17:38:47 cmv Exp $
+// $Id: histos.h,v 1.22 2006-08-11 16:10:13 cmv Exp $
 //
 
@@ -17,7 +17,11 @@
 namespace SOPHYA {
 
+//  Forward class declaration for Fits handler
+template <class T>  class FitsHandler;
+
 //! 1 dimension histograms
 class Histo : public AnyDataObj {
   friend class ObjFileIO<Histo>;
+  friend class FitsHandler<Histo>;
 public:
 
Index: trunk/SophyaLib/HiStats/histos2.h
===================================================================
--- trunk/SophyaLib/HiStats/histos2.h	(revision 3048)
+++ trunk/SophyaLib/HiStats/histos2.h	(revision 3049)
@@ -20,7 +20,11 @@
 namespace SOPHYA {
 
+//  Forward class declaration for Fits handler
+template <class T>  class FitsHandler;
+
 //! 2 dimensions histograms
 class Histo2D : public AnyDataObj {
   friend class ObjFileIO<Histo2D>;
+  friend class FitsHandler<Histo2D>;
 public:
 